export declare function create<Value, Reason = Error>(): ControlledPromise<Value, Reason>;
export declare class ControlledPromise<Value, Reason> {
    readonly controller: Controller<Value, Reason>;
    readonly promise: Promise<Value>;
    constructor(controller: Controller<Value, Reason>, promise: Promise<Value>);
    resolve(value: Value): Promise<Value>;
    reject(reason: Reason): Promise<Value>;
}
export declare class Controller<Value, Reason> {
    readonly resolve: Controller.Resolver<Value>;
    readonly reject: Controller.Rejecter<Reason>;
    constructor(resolve: Controller.Resolver<Value>, reject: Controller.Rejecter<Reason>);
}
export declare namespace Controller {
    type Resolver<X> = (x: Promise<X> | X) => void;
    type Rejecter<X> = (x: X) => void;
}
export default create;
